The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::DelayL Class Reference

STK linear interpolating delay line class. More...

`#include <DelayL.h>`

Inheritance diagram for stk::DelayL:

List of all members.

## Public Member Functions
| DelayL (StkFloat delay=0.0, unsigned long maxDelay=4095)
| Default constructor creates a delay-line with maximum length of 4095 samples and zero delay.
| ~DelayL ()
| Class destructor.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (StkFloat delay)
| Set the delay-line length.
StkFloat | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value which will be output by the next call to tick().
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK linear interpolating delay line class.

This class implements a fractional-length digital delay-line using first-order linear interpolation. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of zero is set.

Linear interpolation is an efficient technique for achieving fractional delay lengths, though it does introduce high-frequency signal attenuation to varying degrees depending on the fractional delay setting. The use of higher order Lagrange interpolators can typically improve (minimize) this attenuation characteristic.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::DelayL::DelayL | ( | StkFloat | delay = `0.0`,
|  | unsigned long | maxDelay = `4095` |
| ) |  |  |

Default constructor creates a delay-line with maximum length of 4095 samples and zero delay.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

void stk::DelayL::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

void stk::DelayL::setDelay | ( | StkFloat | delay | ) |

Set the delay-line length.

The valid range for delay is from 0 to the maximum delay-line length.

StkFloat stk::DelayL::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

StkFloat stk::DelayL::nextOut | ( | void |  | ) | `[inline]`

Return the value which will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

    00121 {
    00122   if ( doNextOut_ ) {
    00123     // First 1/2 of interpolation
    00124     nextOutput_ = inputs_[outPoint_] * omAlpha_;
    00125     // Second 1/2 of interpolation
    00126     if (outPoint_+1 < inputs_.size())
    00127       nextOutput_ += inputs_[outPoint_+1] * alpha_;
    00128     else
    00129       nextOutput_ += inputs_[0] * alpha_;
    00130     doNextOut_ = false;
    00131   }
    00132
    00133   return nextOutput_;
    00134 }

StkFrames & stk::DelayL::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00155 {
    00156 #if defined(_STK_DEBUG_)
    00157   if ( channel >= frames.channels() ) {
    00158     oStream_ << "DelayL::tick(): channel and StkFrames arguments are incompatible!";
    00159     handleError( StkError::FUNCTION_ARGUMENT );
    00160   }
    00161 #endif
    00162
    00163   StkFloat *samples = &frames[channel];
    00164   unsigned int hop = frames.channels();
    00165   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00166     inputs_[inPoint_++] = *samples * gain_;
    00167     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00168     *samples = nextOut();
    00169     doNextOut_ = true;
    00170     if ( ++outPoint_ == inputs_.size() ) outPoint_ = 0;
    00171   }
    00172
    00173   lastFrame_[0] = *(samples-hop);
    00174   return frames;
    00175 }

StkFrames & stk::DelayL::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00178 {
    00179 #if defined(_STK_DEBUG_)
    00180   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00181     oStream_ << "DelayL::tick(): channel and StkFrames arguments are incompatible!";
    00182     handleError( StkError::FUNCTION_ARGUMENT );
    00183   }
    00184 #endif
    00185
    00186   StkFloat *iSamples = &iFrames[iChannel];
    00187   StkFloat *oSamples = &oFrames[oChannel];
    00188   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00189   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00190     inputs_[inPoint_++] = *iSamples * gain_;
    00191     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00192     *oSamples = nextOut();
    00193     doNextOut_ = true;
    00194     if ( ++outPoint_ == inputs_.size() ) outPoint_ = 0;
    00195   }
    00196
    00197   lastFrame_[0] = *(oSamples-oHop);
    00198   return iFrames;
    00199 }

The documentation for this class was generated from the following file:

- DelayL.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.